-- ToME - Tales of Maj'Eyal
-- Copyright (C) 2009, 2010, 2011 Nicolas Casalini
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Nicolas Casalini "DarkGod"
-- darkgod@te4.org
local price = (8 + npc.level) * (1 - (player:getTalentLevel(game.player.T_RECRUITING) / 10))

newChat{ id="welcome",
	text = [[Howdy, stranger.]],
	answers = {
		{"Howdy."},
		{"I'll pay you "..price.." gold if you will fight for me. [pay "..price.." gold]", jump="hire",
			cond=function(npc, player)
				return (player.mercs_in_party < (player:getTalentLevel(player.T_RECRUITING) / 2 ) + 1 ) and player.money >= price
			end,
			action=function(npc, player) player:incMoney(-price) end
		},
		{"I'd like to hire you, but I can't manage that many people at once.",
			cond=function(npc, player)
				return not (player.mercs_in_party < (player:getTalentLevel(player.T_RECRUITING) / 2 ) + 1 )
			end,
		},
		{"I'd like to hire you, but I can't afford the "..price.." gold you would charge.",
			cond=function(npc, player)
				return not (player.money >= price)
			end,
		}
	}
}

newChat{ id="hire",
	text = [[How can I say no to a deal like that?]],
	answers =
	{
		{"Welcome to the group!", action=function(npc, player)
			player.mercs_in_party = player.mercs_in_party + 1
			npc.ai_state.tactic_leash = 100
			npc.can_talk = nil
			silent_levelup = true
			npc.summoner = player
			npc.summoner_gain_exp = true
			npc.mercenary = true
--			npc.combat_armor = npc.combat_armor + player:getTalentLevel(player.T_MAINTENANCE)*5
--			npc.combat_dam = npc.combat.dam + player:getTalentLevel(player.T_MAINTENANCE)*2
			npc.inc_stats = {
			str=player:getTalentLevel(player.T_TRAINING)*2,
			dex=player:getTalentLevel(player.T_TRAINING)*2,
			mag=player:getTalentLevel(player.T_TRAINING)*2,
			wil=player:getTalentLevel(player.T_TRAINING)*2,
			cun=player:getTalentLevel(player.T_TRAINING)*2,
			con=player:getTalentLevel(player.T_TRAINING)*2,
			}

			npc.on_die = function(self, who)
				game.party:removeMember(self, true)
				self:disappear()
				self:removed()
				player.mercs_in_party = player.mercs_in_party - 1
			end

			if player:getTalentLevelRaw(player.T_ORDERS) == 1 then
				game.party:addMember(npc, {
					control="order",
					title="Mercenary",
					orders = {target=true},
				})
			elseif player:getTalentLevelRaw(player.T_ORDERS) == 2 then
				game.party:addMember(npc, {
					control="order",
					title="Mercenary",
					orders = {target=true, leash=true},
				})
			elseif player:getTalentLevelRaw(player.T_ORDERS) == 3 then
				game.party:addMember(npc, {
					control="order",
					title="Mercenary",
					orders = {target=true, leash=true, anchor=true},
				})
			elseif player:getTalentLevelRaw(player.T_ORDERS) == 4 then
				game.party:addMember(npc, {
					control="order",
					title="Mercenary",
					orders = {target=true, leash=true, anchor=true, talents=true},
				})
			elseif player:getTalentLevelRaw(player.T_ORDERS) >= 5 then
				game.party:addMember(npc, {
					control="order",
					title="Mercenary",
					orders = {target=true, leash=true, anchor=true, talents=true, behavior=true},
				})
			else
				game.party:addMember(npc, {
					control="order",
					title="Mercenary",
				})
			end
		end},
	},
}

return "welcome"
 